/************************************************************************/
/*  Copyright (C), 2016-2020, [IT], Ȩ;
/*  ģ  ģ飬δŻ;
/*      ;
/*
/*      [V];	
/*      ߣ[IT];
/*      ڣ[7/26/2016];
/*
/*
/*  ע    ⣺;
/*
/*  ޸ļ¼[IT];
/*  ޸ڣ;
/*  ޸İ汾;
/*  ޸ݣ;
/************************************************************************/
#ifndef __CHAR_ENCODING__
#define __CHAR_ENCODING__

#include <string>
#include <vector>
using namespace std;

#ifndef _UNICODE
typedef string TString;
#else
typedef wstring TString;
#endif

#pragma once


class  CharEncoding
{
public:
	// ַתΪӦASCIIʮֵ;
	static char CharToInt(char ch);
	// ַתʮֵ;
	static char StrToBin(IN char (&str)[2]);
	static void GB2312ToUTF_8(string& pOut, const char *pText, int pLen);
	// ASCIIַתUNICODEַ;
	static WCHAR* ASCII2UNICODE(IN LPCCH lpASCIIStr);
	static BOOL   ASCII2UNICODE(IN LPCCH lpASCIIStr, OUT PWCH pUNICODEStr, IN CONST INT& nUNICODEStrLen);
	static BOOL   ASCII2UNICODE(IN LPCCH lpASCIIStr, OUT wstring &strResult);

	// UNICODEַתASCIIַ;
	static CHAR* UNICODE2ASCII(IN LPWCH lpUNICODEStr);
	static BOOL  UNICODE2ASCII(IN LPWCH lpUNICODEStr, OUT LPCH pASCIIStr, IN CONST INT& nASCIIStrLen);
	static BOOL  UNICODE2ASCII(IN LPWCH lpUNICODEStr, OUT string &strResult);

	// UNICODEַתUFT8ַ;
	static CHAR* UNICODE2UTF8(IN LPWCH lpUNICODEStr);
	static BOOL  UNICODE2UTF8(IN LPWCH lpUNICODEStr, OUT LPCH pUTF8Str, IN CONST INT& nUTF8StrLen);
	static BOOL  UNICODE2UTF8(IN LPWCH lpUNICODEStr, OUT string &strResult);

	// ASCIIַתUTF8ַ;
	static CHAR* ASCII2UTF8(IN LPCCH lpASCIIStr);
	static BOOL  ASCII2UTF8(IN LPCCH lpASCIIStr, OUT LPCH pUTF8Str, IN CONST INT& nUTF8StrLen);
	static BOOL  ASCII2UTF8(IN LPCCH lpASCIIStr, OUT string &strResult);

	// UTF-8ַתUNICODEַ;
	static WCHAR* UTF82UNICODE(IN LPCCH lpUTF8);
	static BOOL   UTF82UNICODE(IN LPCCH lpUTF8, OUT PWCH pUNICODEStr, IN CONST INT& nUNICODEStrLen);
	static BOOL   UTF82UNICODE(IN LPCCH lpUTF8, OUT wstring &strResult);

	// UTF-8ַתASCIIַ;
	static CHAR*  UTF82ASCII(IN LPCCH lpUTF8);
	static BOOL   UTF82ASCII(IN LPCCH lpUTF8, OUT LPCH pASCIIStr, IN CONST INT& nASCIIStrLen);
	static BOOL   UTF82ASCII(IN LPCCH lpUTF8, OUT string &strResult);

	// UTF-8GB2312;
	static string UTF8IntoGB2313(IN CHAR* pUTF8Text, IN const INT& nUTF8TextLen);
	// GB2312UTF-8;
	static string GB2312IntoUTF8(IN CHAR* pGB2312Text, IN const INT& nGB2312TextLen);

	// ַΪGB2312ʽURL;
	static string EnCode_GB2312URL(IN CHAR* pText);
	static void EnCode_GB2312URL(IN CHAR* pText, OUT string& strResult);
	// ַΪUTF-8ʽURL;
	static string EnCode_UTF8URL(IN const CHAR* pText);
	static void EnCode_UTF8URL(IN const CHAR* pText, OUT string& strResult);
	// ַΪUNICODEʽURL;
	static string EnCode_UNICODEURL(IN const CHAR* pText);	// δɸú;

	// UTF-8ʽURL;
	static string DeCode_URLUTF8(IN const CHAR* pURLText);
	static void DeCode_URLUTF8(IN const CHAR* pURLText, OUT string& strResult);
	// GB2312ʽURL;
	static string DeCode_URLGB2312(IN const CHAR* pURLText);
	static void DeCode_URLGB2312(IN const CHAR* pURLText, OUT string& strResult);
	// UNICODEʽURL;
	static string DeCode_URLUNICODE(IN const CHAR* pURLText);
	static void DeCode_URLUNICODE(IN const CHAR* pURLText, OUT string& strResult);
};

#endif