#pragma once

#include "Protocol.h"

#define CONNECTING_STATE 0
#define READING_STATE 1
#define WRITING_STATE 2
#define INSTANCES 4
#define PIPE_TIMEOUT 5000
#define BUFSIZE 4096

// ܵɶ˿ͶݵI/O
typedef enum _OPERATION_TYPE
{
    OP_ACCEPT, // Accept;
    OP_SEND,   // Ͳ
    OP_RECV,   // ղ
    OP_MAX     // ;
} OPERATION_TYPE;

extern void dprintf(TCHAR* pszStr, ...);
// IO;
typedef struct _PER_IO_CONTEXT
{
    OVERLAPPED m_Overlapped;
    HANDLE m_PipeAccept;
    OPERATION_TYPE m_OpType;
	// տͻ˵Ϣ;
    BYTE szBuffer[BUFSIZE];
    DWORD dwBufferLine;
	// ͸ͻϢ;
    //TCHAR chReply[BUFSIZE];
    //DWORD cbToWrite;
    // ܵ״̬;
    //DWORD dwState;
    // IOǷڵȴ;
    //BOOL fPendingIO;
	// дIO;
	_PER_IO_CONTEXT *pWriteIoContext;
    
    // ʼ
    _PER_IO_CONTEXT()
    {
        ZeroMemory(&m_Overlapped, sizeof(m_Overlapped));
        ZeroMemory(szBuffer, BUFSIZE);
        //ZeroMemory(chReply, BUFSIZE);
		m_PipeAccept = INVALID_HANDLE_VALUE;
        m_OpType = OP_ACCEPT;
		pWriteIoContext = NULL;
        //fPendingIO = FALSE;
        //dwState = 0;
    }

    // ͷŵ
    ~_PER_IO_CONTEXT()
    {		
        if (m_PipeAccept != INVALID_HANDLE_VALUE)
        {
            //CloseHandle(m_PipeAccept);// ˴CloseHandleΪm_PipeAcceptPER_PIPE_CONTEXTͷ;
            m_PipeAccept = INVALID_HANDLE_VALUE;
        }

		if ( pWriteIoContext )
			delete pWriteIoContext;
		pWriteIoContext = NULL;
    }

    // û
    void ResetBuffer()
    {
		dprintf(_T("ResetBuffer:%p"), &m_Overlapped);
        ZeroMemory(szBuffer, BUFSIZE);
        //ZeroMemory(chReply, BUFSIZE);
    }

} PER_IO_CONTEXT, *PPER_IO_CONTEXT;

typedef struct _PER_PIPE_CONTEXT
{
	HANDLE m_hPipe;
	// ͻ˽PID;
	DWORD dwProcessId;
	// ͻ˽̴;
	TCHAR szClientName[255];
	// PipeµIO¼;
	CArray<_PER_IO_CONTEXT*> m_arrayIoContext;

	_PER_PIPE_CONTEXT()
	{
		m_hPipe = INVALID_HANDLE_VALUE;
		dwProcessId = 0;
		memset(szClientName, 0, sizeof(TCHAR)*255);
	}

	~_PER_PIPE_CONTEXT()
	{
		if ( m_hPipe != INVALID_HANDLE_VALUE )
		{
			CloseHandle(m_hPipe);
			m_hPipe = INVALID_HANDLE_VALUE;

			// ͷŵеIO
			for( int i=0; i<m_arrayIoContext.GetCount(); i++ )
			{
				delete m_arrayIoContext.GetAt(i);
			}
			m_arrayIoContext.RemoveAll();
		}
	}

	// ÿͻϢ;
	void SetClientInfo(DWORD dwClientId, LPCTSTR lpszClientName)
	{
		dwProcessId = dwClientId;
		_stprintf_s(szClientName, _T("%s"), lpszClientName == NULL ? _T("Null") : lpszClientName);
	}

	// ȡһµIoContext
	_PER_IO_CONTEXT* GetNewIoContext()
	{
		_PER_IO_CONTEXT* p = new _PER_IO_CONTEXT;

		m_arrayIoContext.Add( p );

		return p;
	}

	// ƳһָIoContext
	void RemoveContext( _PER_IO_CONTEXT* pContext )
	{
		ASSERT( pContext!=NULL );
		for( int i=0; i<m_arrayIoContext.GetCount(); i++ )
		{
			if( pContext == m_arrayIoContext.GetAt(i) )
			{
				if ( pContext->pWriteIoContext )
					delete pContext->pWriteIoContext;
				delete pContext;
				pContext = NULL;
				m_arrayIoContext.RemoveAt(i);				
				break;
			}
		}
	}
}PER_PIPE_CONTEXT, *PPER_PIPE_CONTEXT;

// صͻ˽ʱ;
typedef BOOL(CALLBACK *OnGoCallback)(DATAHEADER *pHeader, MSG_INFO* pMsg);
// صͻ˽ʱ;
typedef BOOL(CALLBACK *OnConnectCallback)(DATAHEADER *pHeader, MSG_INFO* pMsg);
// صͻ˶Ͽʱ;
typedef BOOL(CALLBACK* OnDisconnectCallback)(PER_IO_CONTEXT* pIoContext);
// صͻϢʱ;
typedef BOOL(CALLBACK *OnReciveCallback)(PER_PIPE_CONTEXT *pPipeContext, PER_IO_CONTEXT *pIoContext);

// ̵̲߳߳
class CIOCPPipe;
typedef struct _tagThreadParams_WORKER
{
    CIOCPPipe *pIOCPModel;	// ָ룬ڵеĺ
    int nThreadNo;          // ̱߳

} THREADPARAMS_WORKER, *PTHREADPARAM_WORKER;


// CIOCPPipe
class CIOCPPipe
{
public:
    CIOCPPipe(void);
    ~CIOCPPipe(void);

public:
    // 
    bool Start();
    //	ֹͣ
    void Stop();
    // ָ룬ڵʾϢ
    void SetMainDlg(CDialog *p) { m_pMain = p; }
	// ͻ˷Ϣ;
	BOOL SendPackage(DATAHEADER &header, MSG_INFO &msg);
	// SetCallback;
	static void SetCallBack(LPVOID lpOnConnect, LPVOID lpOnDisconnect, LPVOID lpOnGo, LPVOID lpOnRecive)
	{
		if ( lpOnConnectCallback == NULL )
			lpOnConnectCallback = (OnConnectCallback)lpOnConnect;

		if ( lpOnDisconnectCallback == NULL )
			lpOnDisconnectCallback = (OnDisconnectCallback)lpOnDisconnect;

		if ( lpOnGoCallback == NULL )
			lpOnGoCallback = (OnGoCallback)lpOnGo;

		if ( lpOnReciveCallback == NULL )
			lpOnReciveCallback = (OnReciveCallback)lpOnRecive;
	}
protected:
    // ʼIOCP
    bool InitIOCP();
    // ͷԴ
    void DeInitialize();
    // ͶAccept
    bool PostAccept();
    // Ͷݽ
    bool PostRecv(PER_IO_CONTEXT *pIoContext);
    // пͻʱ򣬽д
    bool DoAccpet(PER_PIPE_CONTEXT *pPipeContext, PER_IO_CONTEXT *pIoContext);
    // нյݵʱ򣬽д
    bool DoRecv(PER_PIPE_CONTEXT *pPipeContext, PER_IO_CONTEXT *pIoContext);
    // ͻ˵Ϣ洢
    void AddToContextList(PER_PIPE_CONTEXT *pPipeContext);
    // ͻ˵ϢƳ
    void RemoveContext(PER_PIPE_CONTEXT *pPipeContext);
    // տͻϢ
    void ClearContextList();
    // 󶨵ɶ˿
    bool AssociateWithIOCP(PER_IO_CONTEXT *pIoContext);
    // ɶ˿ϵĴ
    bool HandleError(PER_PIPE_CONTEXT *pPipeContext, const DWORD &dwErr);
    // ̺߳ΪIOCPĹ߳
    static DWORD WINAPI _WorkerThread(LPVOID lpParam);
    // ñĴ
    int GetNoOfProcessors();
    // жϿͻSocketǷѾϿ
    bool IsSocketAlive(SOCKET s);
    // ʾϢ
    void ShowMessage(const CString szFormat, ...) const;
	// ֵ;
	void RecvProcess(PER_PIPE_CONTEXT* pPipeContext, PER_IO_CONTEXT* pIoContext);

private:
	static OnConnectCallback lpOnConnectCallback;
	static OnDisconnectCallback lpOnDisconnectCallback;
	static OnGoCallback lpOnGoCallback;
	static OnReciveCallback lpOnReciveCallback;
    HANDLE m_hShutdownEvent; // ֪ͨ߳ϵͳ˳¼Ϊܹõ˳߳
    HANDLE m_hIOCompletionPort; // ɶ˿ڵľ
    HANDLE *m_phWorkerThreads; // ̵߳ľָ
    int m_nThreads; // ɵ߳
    CDialog *m_pMain; // Ľָ룬ʾϢ
    CRITICAL_SECTION m_csContextList; // Worker߳ͬĻ
    CArray<PER_PIPE_CONTEXT *> m_arrayClientContext; // ͻSocketContextϢ
};
