#include "stdafx.h"
#include "SortHeaderCtrl.h"

CSortHeaderCtrl::CSortHeaderCtrl(): m_nSortColumn( -1 ), m_bSortAscending( TRUE )
{
	m_bPressMoused		= FALSE;
	//m_clrColumText		= RGB(255,255,255);
	//m_clr3DHighLight	= RGB(220, 220, 220);	//::GetSysColor(COLOR_3DHIGHLIGHT);
	//m_clr3DShadow		= RGB(35, 35, 35);		//::GetSysColor(COLOR_3DSHADOW);
	//m_clr3DFace			= RGB(128, 128, 128);	//::GetSysColor(COLOR_3DFACE);

	m_clrColumText		= RGB(7,30,129);
	m_clr3DHighLight	= RGB(107, 201, 255);	//::GetSysColor(COLOR_3DHIGHLIGHT);
	m_clr3DShadow		= RGB(37, 121, 176);		//::GetSysColor(COLOR_3DSHADOW);
	m_clr3DFace			= RGB(105, 201, 255);	//::GetSysColor(COLOR_3DFACE);
}

CSortHeaderCtrl::~CSortHeaderCtrl()
{
}

BEGIN_MESSAGE_MAP(CSortHeaderCtrl, CHeaderCtrl)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

/************************************************************************/
/*  SetSortArrow[10/20/2016 IT];
/*  ҪԼʽ;
/*  ;
/*  	[IN] ;
/*  	[OUT] ;
/*  	[IN/OUT] ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
void CSortHeaderCtrl::SetSortArrow( IN const int nSortColumn, IN const BOOL bSortAscending )
{
	m_nSortColumn = nSortColumn;
	m_bSortAscending = bSortAscending;

	// Ի;
	HD_ITEM hditem;
	hditem.mask = HDI_FORMAT;
	// ȡϢ;
	VERIFY( GetItem( nSortColumn, &hditem ) );
	// Ի;
	hditem.fmt |= HDF_OWNERDRAW;
	// Ϣ;
	VERIFY( SetItem( nSortColumn, &hditem ) );

	// ±ͷԱػ;
	Invalidate();
}

BOOL CSortHeaderCtrl::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CSortHeaderCtrl::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	int nItems = GetItemCount();
	ASSERT(nItems >= 0);
	dc.SetBkColor(m_clr3DFace);
	dc.SetTextColor(m_clrColumText);

	CRect rectClip;
	if (dc.GetClipBox(&rectClip) == ERROR)
		return;
	dc.FillSolidRect(rectClip, m_clr3DFace);

	// ȡǰλ;
	POINT point;
	GetCursorPos(&point);
	ScreenToClient(&point);

	CRect rectItem;
	for(int i = 0; i < nItems; i++)
	{
		TCHAR szText[256];
		HD_ITEM hditem;

		hditem.mask = HDI_TEXT | HDI_FORMAT | HDI_ORDER;
		hditem.pszText = szText;
		hditem.cchTextMax = 255;
		GetItem( i, &hditem );

		DRAWITEMSTRUCT DrawItemStruct;
		GetItemRect(i, &rectItem);

		DrawItemStruct.CtlType        = ODT_BUTTON;
		DrawItemStruct.hDC            = dc.GetSafeHdc();
		DrawItemStruct.itemAction     = ODA_DRAWENTIRE; 
		DrawItemStruct.hwndItem       = GetSafeHwnd(); 
		DrawItemStruct.rcItem         = rectItem;
		DrawItemStruct.itemID         = i;
		if ( rectItem.PtInRect(point) && m_bPressMoused )
			DrawItemStruct.itemState = ODS_SELECTED;
		DrawItemEx(&DrawItemStruct);
	}
}

/************************************************************************/
/*  DrawItemEx[10/19/2016 IT];
/*  Ի溯;
/*  ;
/*  	[IN] ;
/*  	[OUT] ;
/*  	[IN/OUT] ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
void CSortHeaderCtrl::DrawItemEx( IN LPDRAWITEMSTRUCT lpDrawItemStruct )
{
	// 豸;
	CDC dc;	
	// 豸ľ;
	VERIFY( dc.Attach( lpDrawItemStruct->hDC ) );

	// 豸;
	const int nSavedDC = dc.SaveDC();

	// ȡǰ;
	CRect rc( lpDrawItemStruct->rcItem );

	// ʵеԪ3DЧ;
	dc.Draw3dRect(rc, m_clr3DHighLight, m_clr3DShadow);
	rc.InflateRect(-1,-1);
	dc.FillSolidRect(rc, m_clr3DFace);
	dc.SetBkMode(TRANSPARENT);

	// ıɫ;
	dc.SetTextColor(m_clrColumText);

	// ָԭС;
	rc = lpDrawItemStruct->rcItem;

	// ȡǰеĿϢ;
	TCHAR szText[ 256 ];
	HD_ITEM hditem;
	hditem.mask = HDI_TEXT | HDI_FORMAT;
	hditem.pszText = szText;
	hditem.cchTextMax = 255;
	VERIFY( GetItem( lpDrawItemStruct->itemID, &hditem ) );

	// еıƸʽ;
	UINT uFormat = DT_SINGLELINE | DT_NOPREFIX | DT_NOCLIP | DT_VCENTER | DT_END_ELLIPSIS ;

	if( hditem.fmt & HDF_CENTER)
		uFormat |= DT_CENTER;
	else if( hditem.fmt & HDF_RIGHT)
		uFormat |= DT_RIGHT;
	else
		uFormat |= DT_LEFT;

	// £µ;
	if( lpDrawItemStruct->itemState == ODS_SELECTED )
	{
		rc.left++;
		rc.top += 2;
		rc.right++;
		// ͷ갴±־;
		m_bPressMoused = FALSE;
	}

	// ͷͼ(rcIcon);
	CRect rcIcon( lpDrawItemStruct->rcItem );
	const int nOffset = ( rcIcon.bottom - rcIcon.top ) / 4;

	// adjust the rect further if the sort arrow is to be displayed.
	if( lpDrawItemStruct->itemID == (UINT)m_nSortColumn )
		rc.right -= 3 * nOffset;

	rc.left += nOffset;
	rc.right -= nOffset;

	// ı;
	if( rc.left < rc.right )
		dc.DrawText( szText, -1, rc, uFormat );

	// ͷ;
	if( lpDrawItemStruct->itemID == (UINT)m_nSortColumn )
	{
		// ƼͷĻ;
		CPen penLight( PS_SOLID, 1, GetSysColor( COLOR_3DHILIGHT ) );
		CPen penShadow( PS_SOLID, 1, GetSysColor( COLOR_3DSHADOW ) );
		CPen* pOldPen = dc.SelectObject( &penLight );

		if( m_bSortAscending )
		{
			// ϵļͷ;
			dc.MoveTo( rcIcon.right - 2 * nOffset, nOffset);
			dc.LineTo( rcIcon.right - nOffset, rcIcon.bottom - nOffset - 1 );
			dc.LineTo( rcIcon.right - 3 * nOffset - 2, rcIcon.bottom - nOffset - 1 );
			dc.SelectObject( &penShadow );
			dc.MoveTo( rcIcon.right - 3 * nOffset - 1, rcIcon.bottom - nOffset - 1 );
			dc.LineTo( rcIcon.right - 2 * nOffset, nOffset - 1);		
		}
		else
		{
			// µļͷ;
			dc.MoveTo( rcIcon.right - nOffset - 1, nOffset );
			dc.LineTo( rcIcon.right - 2 * nOffset - 1, rcIcon.bottom - nOffset );
			dc.SelectObject( &penShadow );
			dc.MoveTo( rcIcon.right - 2 * nOffset - 2, rcIcon.bottom - nOffset );
			dc.LineTo( rcIcon.right - 3 * nOffset - 1, nOffset );
			dc.LineTo( rcIcon.right - nOffset - 1, nOffset );		
		}

		// ָԭѡĻ;
		dc.SelectObject( pOldPen );
	}

	// ָ֮ǰ豸;
	VERIFY( dc.RestoreDC( nSavedDC ) );

	// ֮ǰ豸ľ;
	dc.Detach();
}

/************************************************************************/
/*  [10/20/2016 IT];
/*  ;
/*  ;
/*  	[IN] ;
/*  	[OUT] ;
/*  	[IN/OUT] ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
void CSortHeaderCtrl::Serialize( CArchive& ar )
{
	try
	{
		if( ar.IsStoring() )
		{
			const int nItemCount = GetItemCount();
			if( nItemCount != -1 )
			{
				ar << nItemCount;

				HD_ITEM hdItem = { 0 };
				hdItem.mask = HDI_WIDTH | HDI_ORDER;
				for( int i = 0; i < nItemCount; i++ )
				{
					VERIFY( GetItem( i, &hdItem ) );
					ar << hdItem.cxy;
					ar << hdItem.iOrder;
				}
			}
		}
		else
		{
			int nItemCount;
			ar >> nItemCount;

			if( GetItemCount() != nItemCount )
				TRACE( _T("Different number of columns in registry.") );
			else
			{
				HD_ITEM hdItem = { 0 };
				hdItem.mask = HDI_WIDTH | HDI_ORDER;

				for( int i = 0; i < nItemCount; i++ )
				{
					ar >> hdItem.cxy;
					ar >> hdItem.iOrder;
					VERIFY( SetItem( i, &hdItem ) );
				}
			}
		}
	}
	catch(...)
	{
	}
}

BOOL CSortHeaderCtrl::PreTranslateMessage(MSG* pMsg)
{
	// TODO: ڴרô/û
	if ( pMsg->message == WM_LBUTTONDOWN )
	{
		m_bPressMoused = TRUE;
	}

	return CHeaderCtrl::PreTranslateMessage(pMsg);
}

/************************************************************************/
/*  SetTextFont[3/6/2017 Jeff];
/*  ı;
/*  ;
/*  	[IN] nTextFontSizeС;
/*  	[IN] bBoldǷ;
/*  	[IN] bItalicǷб;
/*  	[IN] strTextFontNameƣ翬;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
void CSortHeaderCtrl::SetListFont(IN CString strFontName, IN int nFontSize, IN BOOL bBold, IN BOOL bItalic)
{
	LOGFONT lf;
	CClientDC dc(this);
	int dpy = GetDeviceCaps(dc, LOGPIXELSY); // Pixel per inch
	lf.lfHeight = -MulDiv(nFontSize, dpy, 72);
	lf.lfWeight = 0;
	lf.lfEscapement = 0;
	lf.lfOrientation = 0;
	if (bBold)
		lf.lfWeight = FW_BLACK;
	else
		lf.lfWeight = FW_NORMAL;
	lf.lfItalic = bItalic;
	lf.lfUnderline = FALSE;
	lf.lfStrikeOut = 0;
	lf.lfCharSet = ANSI_CHARSET;
	lf.lfOutPrecision = OUT_DEFAULT_PRECIS;
	lf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	lf.lfQuality = DEFAULT_QUALITY;
	lf.lfPitchAndFamily = DEFAULT_PITCH | FF_ROMAN;

	_tcscpy_s(lf.lfFaceName, strFontName);

	// ;
	//m_cfont = GetFont();// ֲᵼʧ,ȫֻԱ;
	VERIFY(m_cfont.CreateFontIndirect(&lf));
	// ѡ;
	this->SetFont(&m_cfont);
}